/* Copyright (C) 2007, 2008, 2009 Stefan Frenz
 * 
 * This file is part of SJC, the Small Java Compiler written by Stefan Frenz.
 * 
 * SJC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SJC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SJC. If not, see <http://www.gnu.org/licenses/>.
 */

package compbase;

/**
 * ExConstInitObj: parent of constant objects created at compile time
 * 
 * @author S. Frenz
 * @version 091005 moved to compbase-package
 *  version 091001 adopted changed memory interface
 *  version 090718 adopted move of modifier flags from Vrbl to AccVar
 *  version 090207 added copyright notice
 *  version 080616 added dependsOn, got getCompInitConstObjectVrbl
 *  version 070918 initial version
 */

public abstract class ExConstInitObj extends ExAccVrbl {
  public Vrbl target;
  public Mthd dependsOn; //if set, check if method code is generated
  
  public ExConstInitObj(int fid, int il, int ic) {
    super(fid, il, ic);
    dest=target=new Vrbl(null, AccVar.M_PUB|AccVar.M_FIN|AccVar.M_STAT|AccVar.MF_ISWRITTEN, fid, il, ic);
  }

  public Vrbl getCompInitConstObjectVrbl(Context ctx) {
    return target;
  }
}
