/* Copyright (C) 2005, 2006, 2007, 2008, 2009 Stefan Frenz
 * 
 * This file is part of SJC, the Small Java Compiler written by Stefan Frenz.
 * 
 * SJC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SJC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SJC. If not, see <http://www.gnu.org/licenses/>.
 */

package frontend.sjava;

import compbase.QualID;

/**
 * JScanSym: symbol, used as transfer between JScanner and JParser
 * 
 * @author S. Frenz
 * @version 090207 added copyright notice
 *  version 070114 reduced access level where possible
 *  version 060607 initial version
 */

public class JScanSym {
	protected int type, par; //type and parameter of symbol
	protected int syline, sycol; //line and column of start of symbol
	protected int intBuf; //int-buffer, used for S_NUM / T_BYTE, T_SHORT, T_CHAR, T_INT, T_BOOL
	protected long longBuf; //long-buffer, used for S_NUM / T_LONG
	//public float floatBuf; //float-buffer
	//public double doubleBuf; //double-buffer
	protected String strBuf; //buffer for string-constants
	protected QualID qidBuf; //buffer for identifiers
	
	protected JScanSym() {
		type=JScanner.RES;
		par=JScanner.RES;
	}
}
