/* Copyright (C) 2007, 2008, 2009 Stefan Frenz
 * 
 * This file is part of SJC, the Small Java Compiler written by Stefan Frenz.
 * 
 * SJC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SJC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SJC. If not, see <http://www.gnu.org/licenses/>.
 */

package symbols;

import compbase.TypeRef;

/**
 * TypeRefPool: pool for TypeRefs to avoid multiple TypeRefs containing the same type
 * 
 * @author S. Frenz
 * @version 091001 adopted changed memory interface
 *  version 090207 added copyright notice
 *  version 070802 initial version
 */

public class TypeRefPool {
  private TypeRefPool nextContainer;
  private TypeRef typeRef; //is null for the initial object
  
  public Object findMatchingTypeRef(TypeRef toFind) {
    TypeRefPool cmp=nextContainer;
    
    while (cmp!=null) {
      if (cmp.typeRef!=null && toFind.arrDim==cmp.typeRef.arrDim && toFind.baseType==cmp.typeRef.baseType
          && toFind.inlinedArraySize==cmp.typeRef.inlinedArraySize && (toFind.qid==null
              || (cmp.typeRef.qid!=null && toFind.qid.unitDest==cmp.typeRef.qid.unitDest)))
        return cmp.typeRef.symHint;
      cmp=cmp.nextContainer;
    }
    cmp=new TypeRefPool();
    cmp.typeRef=toFind;
    cmp.nextContainer=nextContainer;
    nextContainer=cmp;
    return null;
  }
}
